if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Board]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Board]
GO

CREATE TABLE [dbo].[Board] (
	[Seq] [int] IDENTITY (1, 1) NOT NULL ,
	[Thread] [int] NOT NULL ,
	[Depth] [int] NOT NULL ,
	[Writer] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Pwd] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[Subject] [varchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Mode] [bit] NOT NULL ,
	[IP] [varchar] (15) COLLATE Korean_Wansung_CI_AS NULL ,
	[FileName] [varchar] (1024),
	[FileSize] [varchar] (1024),
	[ReadCount] [int] NOT NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[Board] WITH NOCHECK ADD 
	CONSTRAINT [DF_Board_readcount] DEFAULT (0) FOR [ReadCount],
	CONSTRAINT [DF_Board_transdate] DEFAULT (getdate()) FOR [RegDate],
	CONSTRAINT [PK_Board] PRIMARY KEY  CLUSTERED 
	(
		[Seq]
	)  ON [PRIMARY] 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[BoardComment]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[BoardComment]
GO

CREATE TABLE [dbo].[BoardComment] (
	[Seq] [int] IDENTITY (1, 1) NOT NULL ,
	[ParentSeq] [int] NOT NULL ,
	[Writer] [varchar] (32) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[PWD] [varchar] (16) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Content] [varchar] (1024) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[IP] [varchar] (16) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[RegDate] [datetime] NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[BoardComment] ADD 
	CONSTRAINT [DF_BoardComment_RegDate] DEFAULT (getdate()) FOR [RegDate],
	CONSTRAINT [PK_BoardComment] PRIMARY KEY  CLUSTERED 
	(
		[Seq]
	)  ON [PRIMARY] 
GO
