using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Text;


namespace Board
{
	/// <summary>
	/// Content   Դϴ.
	/// </summary>
	public class Content : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblName, lblDate, lblRead, lblSubject, lblContent, lblError;
		protected System.Web.UI.WebControls.ImageButton btnList, btnReply, btnEdit, btnDelete;
		protected System.Web.UI.WebControls.Repeater rptComment, rptFile;
		protected System.Web.UI.WebControls.TextBox txtPWD, txtCommentWriter, txtComment, txtCommentPWD;
		protected System.Web.UI.WebControls.Button btnSubmit;
		protected System.Web.UI.WebControls.DataList dlList;
		protected System.Web.UI.WebControls.Label lblMail;
		protected string Query = null, seq = null, CurPage = null, Keyword = null, Keyfield = null;
		public string TblName = null;
		


		Common.Function myFunction = new Common.Function();
		Common.DB myDB = new Common.DB();
		StringBuilder sb = new StringBuilder();
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			CheckParam();
			InitButton();
			GetComment();

			if(!IsPostBack)
			{
				GetContent();
				GetList();
			}
		}

		/* Ķ  üũ */
		private void CheckParam() 
		{
			CurPage = Request.QueryString["Page"];
			Keyword = Request.QueryString["Keyword"];
			Keyfield = Request.QueryString["Keyfield"];
			TblName = Request.QueryString["TblName"];

			seq = Request.QueryString["seq"];
			if(seq == string.Empty || seq == null)
			{
				Response.Redirect("List.aspx?TblName="+TblName);
				Response.End();
			}

			if (TblName == null || TblName == string.Empty) 
			{
				TblName = "Board";
			}
		}

		/* Button Ӽ ߰ */
		private void InitButton()
		{
			btnSubmit.Attributes.Add("onclick", "return chkComment();");
			btnEdit.Attributes.Add("onclick", "return OnEdit();");
			btnDelete.Attributes.Add("onclick", "return OnDelete();");
			
		}

		private void UpdateBoardCount() 
		{
			/*    */
			Query = " UPDATE "+ TblName +" SET readcount = readcount + 1 "
				+ " WHERE seq = '"+seq+"'";
			myDB.ExecuteQuery(Query);
		}

		/* ش Խù  */
		private void GetContent()
		{
			string xmlData;
			myDB.DbConn();
			UpdateBoardCount();
			

			Query = " SELECT Seq, Thread, Depth, Writer, Email, Subject, Mode, IP, ReadCount, "
				+ " RegDate, Content, FileName, FileSize FROM " + TblName
				+ " WHERE Seq = '"+ seq +"'";

			SqlDataReader Reader = myDB.FatechQuery(Query);

			if(Reader.Read())
			{
				ViewState["seq"] = Reader[0].ToString();
				ViewState["thread"] = Reader[1].ToString();
				ViewState["depth"] = Reader[2].ToString();

				lblName.Text = Reader[3].ToString();
				lblMail.Text = Reader[4].ToString();
				lblSubject.Text = Reader[5].ToString();
				lblRead.Text = Reader[8].ToString();
				lblDate.Text = Reader[9].ToString();
				
				DataSet ds = new DataSet();
				DataTable dt = new DataTable("FileList");
				dt.Columns.Add("FileName", typeof(string));
				dt.Columns.Add("FileSize", typeof(string));
				ds.Tables.Add(dt);

				xmlData = GetXMLFileList(Reader[11].ToString(), Reader[12].ToString());
				
				System.IO.StringReader xmlSR = new System.IO.StringReader(xmlData);
				ds.ReadXml(xmlSR, XmlReadMode.IgnoreSchema);
				rptFile.DataSource = ds.Tables["FileList"];
				rptFile.DataBind();

				bool HtmlMode = (bool)Reader[6];
				if(HtmlMode)
				{
					lblContent.Text = myFunction.ReplaceBR(Reader[10].ToString());
				}
				else
				{
					lblContent.Text = myFunction.ReplaceBR(Server.HtmlEncode(Reader[10].ToString()));
				}
			}
			else
			{
				myFunction.PrintMsgBack("  ʽϴ.");
			}

			myDB.ReaderClose();
			myDB.DbClose();
		}

		/* ش seq Comment Ÿ ε */	
		private void GetComment()
		{
			string xmlData, Seq, Writer, Comment, RegDate;
			myDB.DbConn();
			Query = " SELECT Seq, Writer, Content, CONVERT(Varchar, RegDate, 120) AS RegDates "
				+ " FROM "+ TblName +"Comment " 
				+ " WHERE ParentSeq = '"+ seq +"'"
				+ " ORDER BY RegDate DESC ";

			SqlDataReader Reader = myDB.FatechQuery(Query);

			DataSet ds = new DataSet();
			DataTable dt = new DataTable("CommentList");
			dt.Columns.Add("Seq", typeof(string));
			dt.Columns.Add("Writer", typeof(string));
			dt.Columns.Add("Comment", typeof(string));
			dt.Columns.Add("RegDate", typeof(string));
			ds.Tables.Add(dt);

			xmlData = "<XmlDS>";
			while(Reader.Read())
			{	
				Seq = Reader[0].ToString();
				Writer = myFunction.strCut(Reader[1].ToString(), 12, "");
				Comment = myFunction.ReplaceBR(Reader[2].ToString());
				RegDate = Reader[3].ToString().Substring(5,5) + " " + Reader[3].ToString().Substring(11,5);
				xmlData += GetXMLCommentList(Seq, Writer, Comment, RegDate);
			}
			xmlData += "</XmlDS>";
			myDB.ReaderClose();
			myDB.DbClose();

			System.IO.StringReader xmlSR = new System.IO.StringReader(xmlData);
			ds.ReadXml(xmlSR, XmlReadMode.IgnoreSchema);
			rptComment.DataSource = ds.Tables["CommentList"];
			rptComment.DataBind();
		}

		/* Խù  ε */
		private void GetList()
		{
			int RecordCount, ParentThread, PrevThread;
			PrevThread = (int.Parse(ViewState["thread"].ToString())-1)/1000 * 1000;
			if (int.Parse(ViewState["thread"].ToString())%1000 == 0) 
			{
				ParentThread = (int.Parse(ViewState["thread"].ToString())/1000) * 1000;
			} 
			else 
			{
				ParentThread = ((int.Parse(ViewState["thread"].ToString())/1000)+1) * 1000;
			}
			

			myDB.DbConn();

			Query = " SELECT COUNT(*) FROM "+ TblName
				+" WHERE thread <= "+ParentThread+" AND thread > "+PrevThread;
			RecordCount = myDB.TotalQuery(Query);					// ü Խù
			

			Query = " SELECT TOP "+ RecordCount +" Seq, Thread, Depth, Writer, Subject, " 
				+" ReadCount, RegDate, FileName, "
				+" (SELECT COUNT(*) FROM "+ TblName +"Comment WHERE ParentSeq = "+TblName+".Seq) AS CommentCount "
				+" FROM " + TblName
				+" WHERE thread <= "+ParentThread+" AND thread > "+PrevThread
				+" ORDER BY thread DESC";
			dlList.DataSource = myDB.ExecuteDataSet(Query, TblName, 0, RecordCount);
			dlList.DataKeyField = "FileName";
			dlList.DataBind();
			myDB.DbClose();
		}

		/* Comment List XML   */
		private string GetXMLCommentList(string Seq, string Writer, string Comment, string RegDate)
		{
			string strXML;
			strXML = "<CommentList>"
				+ "<Seq>"+ Seq +"</Seq>"
				+ "<Writer>"+ Writer +"</Writer>"
				+ "<Comment><![CDATA["+ Comment +"]]></Comment>"
				+ "<RegDate>"+ RegDate +"</RegDate>"
				+ "</CommentList>";
			return strXML;		
		}

		/* File List XML   */
		private string GetXMLFileList(string fn, string fs)
		{
			string[] FileNameArr = fn.Split(new Char[]{(char)5});
			string[] FileSizeArr = fs.Split(new Char[]{(char)5});
			string strXML, strFileSize;
			strXML = "<XmlDS>";
			for (int i=0; i < FileNameArr.Length-1; i++)
			{
				if (FileSizeArr[i].Length < 4)
				{
					strFileSize = FileSizeArr[i] + " Kbyte";
				} 
				else 
				{
					strFileSize = (int.Parse(FileSizeArr[i])/1000).ToString() + " Mbyte";
				}

				strXML += "<FileList>"
					+ "<FileName>"+ FileNameArr[i] +"</FileName>"
					+ "<FileSize>"+ strFileSize +"</FileSize>"
					+ "</FileList>";	
				
			}
			
			strXML += "</XmlDS>";
			return strXML;
		}

		/* йȣ üũ */
		private bool IsPasswordValid()
		{
			bool Flag = false;
			myDB.DbConn();

			Query = " SELECT COUNT(*) FROM "+ TblName
				+ " WHERE seq = "+ seq +" AND pwd = "+ txtPWD.Text;

			int Count = myDB.TotalQuery(Query);
			if (Count > 0) 
			{
				Flag = true;
			}
			
			myDB.DbClose();
			return Flag;
		} 

		/* ư Ŭ */
		private void btnDelete_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			bool IsValid = IsPasswordValid();
			if(IsValid)
			{
				DeleteRecord();
				Response.Redirect("List.aspx?TblName="+TblName);
			}
			else
			{
				sb.Append("<script>"
					+ " alert('йȣ ġ ʽϴ');"
					+ " document.Content.txtPWD.focus();"
					+ " </script>");
				this.RegisterStartupScript("Password", sb.ToString());
			}

		}

		/* ش Խù  */
		private void DeleteRecord()
		{
			string[] FileNameArr = null;
			string UploadDir = Request.MapPath(".") + "\\Upload";
			string fn = null;

			int PrevThread, ParentThread;
			string Query1, Query2, ParentSeq;
			myDB.DbConn();

			PrevThread = (int.Parse(ViewState["thread"].ToString())-1)/1000 * 1000;

			/* θ ϴ  */
			if (int.Parse(ViewState["thread"].ToString())%1000 == 0)		
			{
				ParentThread = (int.Parse(ViewState["thread"].ToString())/1000) * 1000;
				Query = " SELECT COUNT(*) FROM "+ TblName +" WHERE thread <= "+ParentThread+" AND thread > "+PrevThread;
				int Count = myDB.TotalQuery(Query);
				string[] QueryArr = new string[Count*2];
				
				Query = " SELECT seq, FileName FROM "+ TblName +" WHERE thread <= "+ParentThread+" AND thread > "+PrevThread;
				SqlDataReader Reader = myDB.FatechQuery(Query);
				int i = 0;
				while(Reader.Read())
				{	
					ParentSeq = Reader[0].ToString();
					fn = Reader[1].ToString();
					if (fn != string.Empty && fn != null) 
					{
						FileNameArr = fn.Split(new Char[]{(char)5});

						foreach (string FileName in FileNameArr) 
						{
							if (FileName != string.Empty && FileName != null) 
							{
								System.IO.FileInfo fi = new System.IO.FileInfo(UploadDir + "\\" + FileName);
								fi.Delete();	
							}
						}
					}

					QueryArr[i] = "DELETE FROM "+ TblName +" WHERE seq = '"+ ParentSeq +"'";
					i++;
					QueryArr[i] = "DELETE FROM "+ TblName +"Comment WHERE ParentSeq = '"+ ParentSeq +"'";
					i++;


				}
				myDB.ReaderClose();
				myDB.InitTransaction("DeleteRoot");
				myDB.ExecuteTransaction(QueryArr);
			} 
			/* 亯  */
			else		
			{
				Query = " SELECT FileName FROM "+ TblName
					+ " WHERE Seq = '"+ seq +"'";
				SqlDataReader Reader = myDB.FatechQuery(Query);

				if(Reader.Read())
				{
					fn = Reader[0].ToString();
					if (fn != string.Empty && fn != null) 
					{
						FileNameArr = fn.Split(new Char[]{(char)5});

						foreach (string FileName in FileNameArr) 
						{
							if (FileName != string.Empty && FileName != null) 
							{
								System.IO.FileInfo fi = new System.IO.FileInfo(UploadDir + "\\" + FileName);
								fi.Delete();	
							}
						}
					}
				}
				myDB.ReaderClose();

				Query1 = " DELETE FROM "+ TblName +" WHERE seq = '"+ seq +"'";
				Query2 = " DELETE FROM "+ TblName +"Comment WHERE ParentSeq = '"+ seq +"'";

				myDB.InitTransaction("BoardDelete");
				string[] QueryArr = new string[] { Query1, Query2 };
				myDB.ExecuteTransaction(QueryArr);
			}
			myDB.DbClose();
		} 


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.btnList.Click += new System.Web.UI.ImageClickEventHandler(this.btnList_Click);
			this.btnReply.Click += new System.Web.UI.ImageClickEventHandler(this.btnReply_Click);
			this.btnEdit.Click += new System.Web.UI.ImageClickEventHandler(this.btnEdit_Click);
			this.btnDelete.Click += new System.Web.UI.ImageClickEventHandler(this.btnDelete_Click);
			this.dlList.ItemCommand += new System.Web.UI.WebControls.DataListCommandEventHandler(this.dlList_ItemCommand);
			this.dlList.ItemDataBound += new System.Web.UI.WebControls.DataListItemEventHandler(this.dlList_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/* Ʈ ư Ŭ */
		private void btnList_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string URL = "List.aspx?KeyField="+Request.QueryString["KeyField"]+"&KeyWord="
				+Request.QueryString["KeyWord"]+"&Page="+Request.QueryString["Page"]
				+"&TblName="+TblName;
			Response.Redirect(URL);
		}


		/*  ư Ŭ */
		private void btnEdit_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			bool IsValid = IsPasswordValid();

			if(IsValid)
			{
				Response.Redirect("Edit.aspx?seq=" + ViewState["seq"].ToString()+"&TblName="+TblName);
			}
			else
			{
				sb.Append("<script>"
					+ " alert('йȣ ġ ʽϴ');"
					+ " document.Content.txtPWD.focus();"
					+ " </script>");

				this.RegisterStartupScript("Password", sb.ToString());
			}
		}

		/* 亯 ư Ŭ */
		private void btnReply_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string seq = ViewState["seq"].ToString();
			string thread = ViewState["thread"].ToString();
			string depth = ViewState["depth"].ToString();
			Response.Redirect("Insert.aspx?seq=" + seq + "&thread=" + thread + "&depth=" + depth+"&TblName="+TblName);
		}

		/* ڸƮ Ȯ ư Ŭ */
		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			myDB.DbConn();
			Query = " INSERT INTO "+ TblName +"Comment ( " 
				+ "	ParentSeq, Writer, PWD, Content, IP  "
				+ " ) VALUES ( "
				+ seq + ","
				+ "'"+ txtCommentWriter.Text +"',"
				+ "'"+ txtCommentPWD.Text +"',"
				+ "'"+ txtComment.Text+"',"
				+ "'"+ Request.UserHostAddress +"')";
			myDB.ExecuteQuery(Query); 
			myDB.DbClose();
			GetComment();
			ClearComment();
		}


		private void ClearComment()
		{
			txtCommentWriter.Text = "";
			txtComment.Text = "";
			txtCommentPWD.Text = "";
		}

		/* ڸƮ ε */
		private void dlList_ItemDataBound(object sender, System.Web.UI.WebControls.DataListItemEventArgs e)
		{
			System.Web.UI.WebControls.HyperLink fcSubject;
			System.Web.UI.WebControls.Label fcWriter;
			System.Web.UI.WebControls.Image fcDepth, fcReply, fcNew, fcFile;

			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				int CurSeq = (int)((DataRowView)e.Item.DataItem)["seq"];
				string subject = (string)((DataRowView)e.Item.DataItem)["subject"];
				string writer = (string)((DataRowView)e.Item.DataItem)["writer"];
				int CommentCount = (int)((DataRowView)e.Item.DataItem)["CommentCount"];

				/*  õ Խù  */
				if (seq == ((DataRowView)e.Item.DataItem)["seq"].ToString()) 
				{
					e.Item.BackColor = System.Drawing.Color.FromName("LightGrey");
				}

				// 亯  reply ̹ depth ̹ 
				int depth = (int)((DataRowView)e.Item.DataItem)["depth"];
				if(depth > 0 )
				{
					fcDepth = (System.Web.UI.WebControls.Image)e.Item.FindControl("imgDepth");
					fcDepth.Visible = true;
					fcDepth.ImageUrl = "Images/blank.gif";
					fcDepth.Height = Unit.Pixel(0);
					fcDepth.Width = Unit.Pixel(depth * 10);
	

					fcReply = (System.Web.UI.WebControls.Image)e.Item.FindControl("imgReply");
					fcReply.Visible = true;
					fcReply.ImageUrl = "Images/re.gif";
				}

				subject = myFunction.strCut(subject, 46 - depth, "..");	
				writer = myFunction.strCut(writer, 8, "");
				
				fcSubject = (System.Web.UI.WebControls.HyperLink)e.Item.FindControl("hlSubject");
				fcSubject.NavigateUrl = "./Content.aspx?seq="+CurSeq+"&Page="+CurPage+"&Keyword="+Keyword
					+"&Keyfield="+Keyfield+"&TblName="+TblName;
				fcSubject.Text = subject;
				
				// ڸƮ  ִ 
				if (CommentCount > 0) 
				{
					subject = myFunction.strCut(subject, 46 -(depth+2), "..");
					fcSubject.Text = subject;
					fcSubject.Text += " <font size='1'>[" + CommentCount.ToString() + "]</font>";
				}
				
				fcWriter = (System.Web.UI.WebControls.Label)e.Item.FindControl("lblWriter");
				fcWriter.Text = writer;

				// 24ð ̳ ö    ʿ ̹ ޾ش.
				DateTime orginDate = (DateTime)((DataRowView)e.Item.DataItem)["regdate"];

				TimeSpan Gap = DateTime.Now - orginDate;

				if(Gap.TotalMinutes < 1440)
				{
					fcNew = (System.Web.UI.WebControls.Image)e.Item.FindControl("imgNew");
					fcNew.Visible = true;
					fcNew.ImageUrl = "Images/new.gif";
				}

				// ε ϸ  
				string fn = (string)((DataRowView)e.Item.DataItem)["FileName"];
				if (fn != string.Empty && fn != null) 
				{
					fcFile = (System.Web.UI.WebControls.ImageButton)e.Item.FindControl("imgBnFile");
					fcFile.Visible = true;
					fcFile.ImageUrl = "images/disk.gif";
					fcFile.ToolTip = fn.Replace(((char)5).ToString(), " ");
				}
			}
		}

		private void dlList_ItemCommand(object source, System.Web.UI.WebControls.DataListCommandEventArgs e)
		{
			string dlKey = dlList.DataKeys[e.Item.ItemIndex].ToString();
			switch (e.CommandName)
			{
					// File ư Ŭ 
				case "File":
					string[] FileArr = dlKey.Split(new Char[]{(char)5});
					string FileExt = System.IO.Path.GetExtension(FileArr[0]).ToLower();

					if (FileExt == ".gif" || FileExt == ".jpg" || FileExt == ".bmp" || FileExt == ".png" || FileExt == ".jpeg")
					{
						StringBuilder sb = new StringBuilder();
					
						sb.Append("<script>"
							+ "location.replace('./Upload/"+FileArr[0]+"');"
							+ "</script>");
						this.RegisterStartupScript("FileDown", sb.ToString());
					} 
					else 
					{
						Response.Redirect("./Down.aspx?FileName="+FileArr[0]);
						Response.End();
					}
					break;
			}
		}
	}
}
