using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Text;

namespace Board
{
	/// <summary>
	/// Edit   Դϴ.
	/// </summary>
	/// 
	
	public class Edit : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.CheckBox UseHTML;
		protected System.Web.UI.WebControls.Label lblError, lblName;
		protected System.Web.UI.WebControls.TextBox txtMail, txtSubject, txtContent;
		protected System.Web.UI.WebControls.ImageButton btnSubmit;
		protected System.Web.UI.WebControls.Repeater rptFile;
		protected string seq = null, Query = null;
		public string TblName = null;
		
		Common.Function myFunction = new Common.Function();
		Common.DB myDB = new Common.DB();
		StringBuilder sb = new StringBuilder();
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			CheckReferrer();
			CheckParam();

			if(!IsPostBack)
			{
				btnSubmit.Attributes.Add("onclick", "return OnSubmit();");
				GetContent();
			}
			else
			{
				seq = ViewState["seq"].ToString();
			}

			// ⿡  ڵ带 ġϿ  ʱȭմϴ.
		}

		/* Ķ  üũ */
		private void CheckParam() 
		{
			seq = Request.QueryString["seq"];
			TblName = Request.QueryString["TblName"];

			if(seq == string.Empty || seq == null)
			{
				Response.Redirect("List.aspx?TblName="+TblName);
				Response.End();
			}
			else
			{
				ViewState["seq"] = seq;
			}

			if (TblName == null || TblName == string.Empty) 
			{
				TblName = "Board";
			}
		}

		private void GetContent()
		{
			string xmlData;
			myDB.DbConn();

			Query = " SELECT Seq, Thread, Depth, Writer, Email, Subject, Mode, IP, ReadCount, "
				+ " RegDate, Content, FileName, FileSize FROM "+ TblName
				+ " WHERE seq = '"+ seq +"'";

			SqlDataReader Reader = myDB.FatechQuery(Query);
			if(Reader.Read())
			{
				lblName.Text = Reader[3].ToString();
				txtMail.Text = Reader[4].ToString();
				txtSubject.Text = Reader[5].ToString();
            
				bool HtmlMode = (bool)Reader[6];
				if(HtmlMode) UseHTML.Checked = true;
				txtContent.Text = Reader[10].ToString();

				DataSet ds = new DataSet();
				DataTable dt = new DataTable("FileList");
				dt.Columns.Add("FileName", typeof(string));
				dt.Columns.Add("FileSize", typeof(string));
				ds.Tables.Add(dt);

				xmlData = GetXMLFileList(Reader[11].ToString(), Reader[12].ToString());

				
				System.IO.StringReader xmlSR = new System.IO.StringReader(xmlData);
				ds.ReadXml(xmlSR, XmlReadMode.IgnoreSchema);
				rptFile.DataSource = ds.Tables["FileList"];
				rptFile.DataBind();
			}
			else
			{
				sb.Append("<script>"
					+ " alert('  ʽϴ');"
					+ " history.back();"
					+ " </script>");
				this.RegisterStartupScript("done", sb.ToString());
			}

			myDB.ReaderClose();
			myDB.DbClose();
		} 

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.rptFile.ItemCommand += new System.Web.UI.WebControls.RepeaterCommandEventHandler(this.rptFile_ItemCommand);
			this.btnSubmit.Click += new System.Web.UI.ImageClickEventHandler(this.btnSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/* File List XML   */
		private string GetXMLFileList(string fn, string fs)
		{
			string[] FileNameArr = fn.Split(new Char[]{(char)5});
			string[] FileSizeArr = fs.Split(new Char[]{(char)5});
			string strXML, strFileSize;
			strXML = "<XmlDS>";
			for (int i=0; i < FileNameArr.Length-1; i++)
			{
				if (FileSizeArr[i].Length < 4)
				{
					strFileSize = FileSizeArr[i] + " Kbyte";
				} 
				else 
				{
					strFileSize = (int.Parse(FileSizeArr[i])/1000).ToString() + " Mbyte";
				}

				strXML += "<FileList>"
					+ "<FileName>"+ FileNameArr[i] +"</FileName>"
					+ "<FileSize>"+ strFileSize +"</FileSize>"
					+ "</FileList>";	
				
			}
			
			strXML += "</XmlDS>";
			return strXML;
		}

		/* Ȯ ư Ŭ */
		private void btnSubmit_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			myDB.DbConn();
			string Content = txtContent.Text.Replace("'","''");
			Query = " UPDATE "+ TblName +" SET email = '"+ txtMail.Text +"', "
				+ " subject = '"+ txtSubject.Text +"', "
				+ " mode = '"+ (UseHTML.Checked == true ? 1 : 0) +"', "
				+ " content = '"+ Content +"', "
				+ " ip = '"+ Request.UserHostAddress +"'"
				+ " WHERE seq = '"+ seq +"'";
			myDB.ExecuteQuery(Query);
			myDB.DbClose();
			
			myFunction.PrintMsg(" Ǿϴ.");
		}

		/*   üũ */
		public void CheckReferrer()
		{
			if(Request.UrlReferrer == null) 
			{
				Response.Redirect("List.aspx?TblName="+TblName);
			}
			else
			{
				string UrlReferrer = Request.UrlReferrer.ToString();
				string ServerUrl = Request.Url.ToString();
				ServerUrl = ServerUrl.Substring(0, ServerUrl.LastIndexOf("/"));
				
				if(UrlReferrer.IndexOf(ServerUrl) == -1) 
				{
					Response.Redirect("List.aspx?TblName="+TblName);
				}
			}
		}
 
		/* ư Ŭ */
		private void rptFile_ItemCommand(object source, System.Web.UI.WebControls.RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "File":
					string FileName = (string)e.CommandArgument; 
					DeleteFile(FileName, seq);
					myFunction.PrintMsg(" "+ FileName+"  Ǿϴ.");
					GetContent();
					break;
			}
		}

		/* File  */
		private void DeleteFile(string FileName, string seq)
		{
			string fn, fs, strFileName = null, strFileSize = null;
			string[] FileNameArr = null, FileSizeArr = null;
			string UploadDir = Request.MapPath(".") + "\\Upload";
			if (FileName != string.Empty && FileName != null) 
			{
				System.IO.FileInfo fi = new System.IO.FileInfo(UploadDir + "\\" + FileName);
				fi.Delete();	
			}
			
			myDB.DbConn();	
			Query = " SELECT FileName, FileSize FROM "+ TblName
				+ " WHERE seq = '"+ seq +"'";
			SqlDataReader Reader = myDB.FatechQuery(Query);

			if(Reader.Read())
			{
				fn = Reader[0].ToString();
				fs = Reader[1].ToString();
				if (fn != string.Empty && fn != null) 
				{
					FileNameArr = fn.Split(new Char[]{(char)5});
					FileSizeArr = fs.Split(new Char[]{(char)5});

					for (int i=0; i < FileNameArr.Length-1; i++)
					{
						if (FileNameArr[i] != string.Empty && FileNameArr[i] != null && FileNameArr[i] != FileName) 
						{
							strFileName += FileNameArr[i] + (char)5;
							strFileSize += FileSizeArr[i] + (char)5;
						}
				
					}
				}
			}
			myDB.ReaderClose();
			Query = " UPDATE "+ TblName +" SET filename = '"+ strFileName+"', "
				+ " filesize = '"+ strFileSize +"'"
				+ " WHERE seq = '"+ seq +"'";
			myDB.ExecuteQuery(Query);
			myDB.DbClose();

		}
	}
}
