using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Text;


namespace Board
{
	/// <summary>
	/// List   Դϴ.
	/// </summary>
	
	public class List : System.Web.UI.Page
	{
		
		protected System.Web.UI.WebControls.Label lblTotal, lbl_Writer, lblPage, lblSearch;
		protected System.Web.UI.WebControls.Image imgDepth, imgReply, imgNew;
		protected System.Web.UI.WebControls.DataList dlList;
		protected System.Web.UI.WebControls.ImageButton ibList;
		protected System.Web.UI.WebControls.DropDownList ddlKeyfield;
		protected System.Web.UI.WebControls.TextBox txtKeyword;
		protected System.Web.UI.WebControls.ImageButton ibWrite, ibSearch, imgBnFile;
		protected System.Web.UI.WebControls.Label lblPageCount;
		protected int nCount, CurPage, StartRecord;

		protected string Keyword = null, Keyfield = null, CurParametter = null, Query = null, TblName = null;
		
		Common.Function myFunction = new Common.Function();
		Common.DB myDB = new Common.DB();
		StringBuilder sb = new StringBuilder();

		private void Page_Load(object sender, System.EventArgs e)
		{

			SetInit(); // ʱ  

			if(!IsPostBack)
			{
				ibSearch.Attributes.Add("onclick", "return OnSearch();");
				GetList();
			}
		}
		
		/* Խù  ε */
		private void GetList()
		{
			int PageSize = 10, PageCount, RecordCount, StartRecord;
			myDB.DbConn();

			Query = " SELECT COUNT(*) FROM " + TblName  
				+ GetSearchQuery(" WHERE", Keyfield, Keyword);

			RecordCount = myDB.TotalQuery(Query);					// ü Խù
			PageCount = (int)((RecordCount - 1) / PageSize) + 1;	//  
			StartRecord = (CurPage - 1) * PageSize;
			lblTotal.Text = RecordCount.ToString();
			lblPageCount.Text = String.Format("{0}/{1}", CurPage, PageCount);

			Query = " SELECT TOP "+ PageSize + " Seq, Thread, Depth, Writer, Subject, " 
				+" Readcount, RegDate, FileName, (SELECT COUNT(*) FROM "+ TblName +"Comment WHERE ParentSeq = "+TblName+".Seq) AS CommentCount "
				+" FROM " + TblName
				+" WHERE seq NOT IN (SELECT TOP "+ StartRecord +" seq FROM "+ TblName +" ORDER BY thread DESC)	"
				+  GetSearchQuery("AND", Keyfield, Keyword)
				+" ORDER BY thread DESC";
			
			dlList.DataSource = myDB.ExecuteDataSet(Query, TblName, 0, PageSize);
			dlList.DataKeyField = "FileName";
			dlList.DataBind();
			
			Common.Pager myPage = new Common.Pager(this, ref lblPage);
			myPage.PageNavigationParametter(CurPage, PageCount, CurParametter);
			myDB.DbClose();
		}
		
		/* Search Query  */
		private string GetSearchQuery(string Keytype, string Keyfield, string Keyword)
		{
			string SearchQuery = null;
			
			if (Keyword != null && Keyword != string.Empty) 
			{
				SearchQuery = Keytype +" " + Keyfield + " LIKE '%"+ Keyword +"%'";
				lblSearch.Text = "˻ : <font color='#FF0000'>" + Keyword + "</font> ˻  Դϴ.";
			}
			
			return SearchQuery;
		}
		
		/* ʱⰪ  */
		private void SetInit() 
		{
			Keyword = Request.QueryString["Keyword"];
			Keyfield = Request.QueryString["Keyfield"];
			TblName = Request.QueryString["TblName"];
			CurParametter = "&TblName="+TblName;	
			if (Keyword != null && Keyword != string.Empty) 
			{
				for(int i=0;i<=ddlKeyfield.Items.Count;i++) 
				{
					if (ddlKeyfield.Items[i].Value == Keyfield) 
					{
						ddlKeyfield.SelectedIndex = i;
						break;
					}
				}
				ibList.Visible = true;
				txtKeyword.Text = Keyword;

				CurParametter += "&Keyword="+ Keyword +"&Keyfield="+Keyfield;
			}

			if (Request.QueryString["Page"] == null) 
			{
				CurPage = 1;
			}
			else 
			{
				CurPage = int.Parse(Request.QueryString["Page"]);
			}

			if (TblName == null || TblName == string.Empty) 
			{
				TblName = "Board";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.dlList.ItemCommand += new System.Web.UI.WebControls.DataListCommandEventHandler(this.dlList_ItemCommand);
			this.dlList.ItemDataBound += new System.Web.UI.WebControls.DataListItemEventHandler(this.dlList_ItemDataBound);
			this.ibWrite.Click += new System.Web.UI.ImageClickEventHandler(this.ibWrite_Click);
			this.ibList.Click += new System.Web.UI.ImageClickEventHandler(this.ibList_Click);
			this.ibSearch.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearch_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/* Խù Ÿ  */
		private void dlList_ItemDataBound(object sender, System.Web.UI.WebControls.DataListItemEventArgs e)
		{
			System.Web.UI.WebControls.HyperLink fcSubject;
			System.Web.UI.WebControls.Label fcWriter;
			System.Web.UI.WebControls.Image fcDepth, fcReply, fcNew, fcFile;

			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				int seq = (int)((DataRowView)e.Item.DataItem)["seq"];
				string subject = (string)((DataRowView)e.Item.DataItem)["subject"];
				string writer = (string)((DataRowView)e.Item.DataItem)["writer"];
				int CommentCount = (int)((DataRowView)e.Item.DataItem)["CommentCount"];

				subject = myFunction.strCut(subject, 46, "...");
				writer = myFunction.strCut(writer, 8, "");

				// 亯  reply ̹ depth ̹ 
				int depth = (int)((DataRowView)e.Item.DataItem)["depth"];
				if(depth > 0 )
				{
					fcDepth = (System.Web.UI.WebControls.Image)e.Item.FindControl("imgDepth");
					fcDepth.Visible = true;
					fcDepth.ImageUrl = "Images/blank.gif";
					fcDepth.Height = Unit.Pixel(0);
					fcDepth.Width = Unit.Pixel(depth * 5);
	
					fcReply = (System.Web.UI.WebControls.Image)e.Item.FindControl("imgReply");
					fcReply.Visible = true;
					fcReply.ImageUrl = "Images/re.gif";
				}
				
				fcSubject = (System.Web.UI.WebControls.HyperLink)e.Item.FindControl("hlSubject");
				fcSubject.NavigateUrl = "./Content.aspx?seq="+seq+"&Keyfield="+Keyfield+"&Keyword="
					+Keyword+"&Page="+CurPage+"&TblName="+TblName;
				fcSubject.Text = subject;

				// ڸƮ  ִ 
				if (CommentCount > 0) 
				{
					subject = myFunction.strCut(subject, 46 -(depth+2), "..");
					fcSubject.Text = subject;
					fcSubject.Text += " <font size='1'>[" + CommentCount.ToString() + "]</font>";
				}
				
				fcWriter = (System.Web.UI.WebControls.Label)e.Item.FindControl("lblWriter");
				fcWriter.Text = writer;
				
				// 24ð ̳ ö    ʿ ̹ ޾ش.
				DateTime orginDate = (DateTime)((DataRowView)e.Item.DataItem)["regdate"];
				TimeSpan Gap = DateTime.Now - orginDate;

				if(Gap.TotalMinutes < 1440)
				{
					fcNew = (System.Web.UI.WebControls.Image)e.Item.FindControl("imgNew");
					fcNew.Visible = true;
					fcNew.ImageUrl = "Images/new.gif";
				}

				// ε ϸ  
				string fn = (string)((DataRowView)e.Item.DataItem)["FileName"];
				if (fn != string.Empty && fn != null) 
				{
					fcFile = (System.Web.UI.WebControls.ImageButton)e.Item.FindControl("imgBnFile");
					fcFile.Visible = true;
					fcFile.ImageUrl = "images/disk.gif";
					fcFile.ToolTip = fn.Replace(((char)5).ToString(), " ");
				}

			}
		}

		/* Ʈ ư Ŭ */	
		private void ibList_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			this.Visible = false;
			Response.Redirect("List.aspx?TblName="+TblName);
			Response.End();
		}

		/* ˻ư Ŭ */
		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			ibList.Visible = true;
			Keyword = txtKeyword.Text;
			Keyfield = ddlKeyfield.SelectedItem.Value.ToString(); 
			GetList();
		}

		private void ibWrite_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Response.Redirect("Insert.aspx?TblName="+TblName);
			Response.End();
		}

		private void dlList_ItemCommand(object source, System.Web.UI.WebControls.DataListCommandEventArgs e)
		{
			string dlKey = dlList.DataKeys[e.Item.ItemIndex].ToString();
			switch (e.CommandName)
			{
				// File ư Ŭ 
				case "File":
					string[] FileArr = dlKey.Split(new Char[]{(char)5});
					string FileExt = System.IO.Path.GetExtension(FileArr[0]).ToLower();

					if (FileExt == ".gif" || FileExt == ".jpg" || FileExt == ".bmp" || FileExt == ".png" || FileExt == ".jpeg")
					{
						StringBuilder sb = new StringBuilder();
					
						sb.Append("<script>"
							+ "location.replace('./Upload/"+FileArr[0]+"');"
							+ "</script>");
						this.RegisterStartupScript("FileDown", sb.ToString());
					} 
					else 
					{
						Response.Redirect("./Down.aspx?FileName="+FileArr[0]);
						Response.End();
					}
					break;
			}
		}
	}
}
